def var h as handle.
def var i as int.
def var ch as char.
def var l as logical.
def var lc as longchar.

/*
D- local-name: SOAP-header-entryref object handle, X-noderef object handle
D- namespace-uri: Buffer object handle, ProDataSet object handle, SOAP-header-entryref object handle, Temp-table object handle, X-document object handle, X-noderef object handle
- get-node(): SOAP-fault-detail object handle, SOAP-header-entryref object handle
- get-serialized(): SOAP-fault-detail object handle, SOAP-header-entryref object handle

- INSTANTIATING-PROCEDURE: all
- UNIQUE-ID: as I recal, there is already an interface for this

Priority features:
Statements:  
- create-soap-header
- create-soap-header-entryref

ATTRIBUTES:
- soap-fault-string /* soap fault object */
- error-status:error-object-detail

METHODS:
- add-header-entry() /* soap header */
- set-must-understand() /* soap header entryref */
- set-node()  /* soap header entryref */
*/

/*soap header object.*/
create soap-header h.
create soap-header h in widget-pool "bla".
create soap-header h in widget-pool ch.

message h:type.
i = h:num-header-entries. /*(r/o, integer)*/
h:num-header-entries = 0. 

l = h:add-header-entry(h).
l = h:get-header-entry(h, 0).
l = h:get-header-entry(h, i).

/* SOAP Header Entryref Object (TYPE = SOAP-HEADER-ENTRYREF):*/
create soap-header-entryref h.
create soap-header-entryref h in widget-pool "bla".
create soap-header-entryref h in widget-pool ch.

message h:type.
ch = h:actor. /*(r/o, character)*/
h:actor = ch. 
ch = h:local-name. /*(r/o, character)*/
h:local-name = ch. 
l = h:must-understand. /*(r/o, logical)*/
h:must-understand = l. 
ch = h:namespace-uri. /*(r/w, character)*/
h:namespace-uri = ch. 
h:namespace-uri = "".
h:namespace-uri = lc. 
h:namespace-uri = ?.

l = h:delete-header-entry().
l = h:get-node(h).
lc = h:get-serialized().
ch = h:get-serialized().
l = h:set-actor(ch).
l = h:set-actor("").
l = h:set-must-understand(l).
l = h:set-must-understand(yes).
l = h:set-node(h).
l = h:set-serialized(lc).

/* SOAP Fault Object (TYPE = SOAP-FAULT): */
message h:type.
ch = h:soap-fault-actor. /*(r/o, character)*/
h:soap-fault-actor = ch.
ch = h:soap-fault-code. /*(r/o, character)*/
h:soap-fault-code = ch.
h = h:soap-fault-detail. /*r/o, handle*/
h:soap-fault-detail = h.
ch = h:soap-fault-string. /* (r/o, character) */
h:soap-fault-string = ch.

h = error-status:error-object-detail. /*(r/o, handle) attribute on error-status system handle*/
error-status:error-object-detail = h.
h = h:error-object-detail.
h:error-object-detail = h.

/* SOAP FAULT DETAIL OBJECT (TYPE = SOAP-FAULT-DETAIL): */
message h:type.
l = h:get-node(h).
lc = h:get-serialized().
ch = h:get-serialized().